diff --git a/gcc/cp/typeck2.c b/gcc/cp/typeck2.c
index 7763d53..8d632db 100644
--- a/gcc/cp/typeck2.c
+++ b/gcc/cp/typeck2.c
@@ -315,61 +315,63 @@ abstract_virtuals_error_sfinae (tree decl, tree type, abstract_class_use use,
   if (!(complain & tf_error))
     return 1;
 
+  diagnostic_group d;
   if (decl)
     {
       if (VAR_P (decl))
-	error ("cannot declare variable %q+D to be of abstract "
-	       "type %qT", decl, type);
+	d.error ("cannot declare variable %q+D to be of abstract "
+		 "type %qT", decl, type);
       else if (TREE_CODE (decl) == PARM_DECL)
 	{
 	  if (DECL_NAME (decl))
-	    error ("cannot declare parameter %q+D to be of abstract type %qT",
-		   decl, type);
+	    d.error ("cannot declare parameter %q+D to be of abstract type %qT",
+		     decl, type);
 	  else
-	    error ("cannot declare parameter to be of abstract type %qT",
-		   type);
+	    d.error ("cannot declare parameter to be of abstract type %qT",
+		     type);
 	}
       else if (TREE_CODE (decl) == FIELD_DECL)
-	error ("cannot declare field %q+D to be of abstract type %qT",
-	       decl, type);
+	d.error ("cannot declare field %q+D to be of abstract type %qT",
+		 decl, type);
       else if (TREE_CODE (decl) == FUNCTION_DECL
 	       && TREE_CODE (TREE_TYPE (decl)) == METHOD_TYPE)
-	error ("invalid abstract return type for member function %q+#D", decl);
+	d.error ("invalid abstract return type for member function %q+#D",
+		 decl);
       else if (TREE_CODE (decl) == FUNCTION_DECL)
-	error ("invalid abstract return type for function %q+#D", decl);
+	d.error ("invalid abstract return type for function %q+#D", decl);
       else if (identifier_p (decl))
 	/* Here we do not have location information.  */
-	error ("invalid abstract type %qT for %qE", type, decl);
+	d.error ("invalid abstract type %qT for %qE", type, decl);
       else
-	error ("invalid abstract type for %q+D", decl);
+	d.error ("invalid abstract type for %q+D", decl);
     }
   else switch (use)
     {
     case ACU_ARRAY:
-      error ("creating array of %qT, which is an abstract class type", type);
+      d.error ("creating array of %qT, which is an abstract class type", type);
       break;
     case ACU_CAST:
-      error ("invalid cast to abstract class type %qT", type);
+      d.error ("invalid cast to abstract class type %qT", type);
       break;
     case ACU_NEW:
-      error ("invalid new-expression of abstract class type %qT", type);
+      d.error ("invalid new-expression of abstract class type %qT", type);
       break;
     case ACU_RETURN:
-      error ("invalid abstract return type %qT", type);
+      d.error ("invalid abstract return type %qT", type);
       break;
     case ACU_PARM:
-      error ("invalid abstract parameter type %qT", type);
+      d.error ("invalid abstract parameter type %qT", type);
       break;
     case ACU_THROW:
-      error ("expression of abstract class type %qT cannot "
+      d.error ("expression of abstract class type %qT cannot "
 	     "be used in throw-expression", type);
       break;
     case ACU_CATCH:
-      error ("cannot declare catch parameter to be of abstract "
+      d.error ("cannot declare catch parameter to be of abstract "
 	     "class type %qT", type);
       break;
     default:
-      error ("cannot allocate an object of abstract type %qT", type);
+      d.error ("cannot allocate an object of abstract type %qT", type);
     }
 
   /* Only go through this once.  */
@@ -378,14 +380,15 @@ abstract_virtuals_error_sfinae (tree decl, tree type, abstract_class_use use,
       unsigned ix;
       tree fn;
 
-      inform (DECL_SOURCE_LOCATION (TYPE_MAIN_DECL (type)),
-	      "  because the following virtual functions are pure within %qT:",
-	      type);
+      d.inform (DECL_SOURCE_LOCATION (TYPE_MAIN_DECL (type)),
+		"  because the following virtual functions are pure within "
+		"%qT:",
+		type);
 
       FOR_EACH_VEC_ELT (*pure, ix, fn)
 	if (! DECL_CLONED_FUNCTION_P (fn)
 	    || DECL_COMPLETE_DESTRUCTOR_P (fn))
-	  inform (DECL_SOURCE_LOCATION (fn), "\t%#qD", fn);
+	  d.inform (DECL_SOURCE_LOCATION (fn), "\t%#qD", fn);
 
       /* Now truncate the vector.  This leaves it non-null, so we know
 	 there are pure virtuals, but empty so we don't list them out
@@ -975,14 +978,16 @@ check_narrowing (tree type, tree init, tsubst_flags_t complain)
 	{
 	  if (complain & tf_warning_or_error)
 	    {
+	      diagnostic_group d;
 	      if ((!almost_ok || pedantic)
-		  && pedwarn (loc, OPT_Wnarrowing,
-			      "narrowing conversion of %qE "
-			      "from %qH to %qI inside { }",
-			      init, ftype, type)
+		  && d.pedwarn (loc, OPT_Wnarrowing,
+				"narrowing conversion of %qE "
+				"from %qH to %qI inside { }",
+				init, ftype, type)
 		  && almost_ok)
-		inform (loc, " the expression has a constant value but is not "
-			"a C++ constant-expression");
+		d.inform (loc,
+			  " the expression has a constant value but is not "
+			  "a C++ constant-expression");
 	      ok = true;
 	    }
 	}
diff --git a/gcc/diagnostic-core.h b/gcc/diagnostic-core.h
index 79b84a7..223ecfd 100644
--- a/gcc/diagnostic-core.h
+++ b/gcc/diagnostic-core.h
@@ -65,11 +65,41 @@ class diagnostic_group
   void maybe_emit_header ();
   void emit_footer ();
 
-  bool warning_at (location_t loc, int opt, const char *gmsgid, ...)
+  bool warning (int opt, const char *, ...)
+    ATTRIBUTE_GCC_DIAG(3,4);
+
+  bool warning_at (location_t, int opt, const char *gmsgid, ...)
     ATTRIBUTE_GCC_DIAG(4,5);
+  bool warning_at (rich_location *, int opt, const char *gmsgid, ...)
+    ATTRIBUTE_GCC_DIAG(4,5);
+
+  void error (const char *, ...)
+    ATTRIBUTE_GCC_DIAG(2,3);
 
-  void inform (location_t loc, const char *gmsgid, ...)
+  void error_at (location_t, const char *, ...)
     ATTRIBUTE_GCC_DIAG(3,4);
+  void error_at (rich_location *, const char *, ...)
+    ATTRIBUTE_GCC_DIAG(3,4);
+
+  bool pedwarn (location_t, int, const char *, ...)
+    ATTRIBUTE_GCC_DIAG(4,5);
+  bool pedwarn (rich_location *, int, const char *, ...)
+    ATTRIBUTE_GCC_DIAG(4,5);
+
+  bool permerror (location_t, const char *, ...)
+    ATTRIBUTE_GCC_DIAG(3,4);
+
+  void inform (location_t, const char * ...)
+    ATTRIBUTE_GCC_DIAG(3,4);
+  void inform (rich_location *, const char *, ...)
+    ATTRIBUTE_GCC_DIAG(3,4);
+  void inform_n (location_t, unsigned HOST_WIDE_INT, const char *,
+		 const char *, ...)
+    ATTRIBUTE_GCC_DIAG(4,6) ATTRIBUTE_GCC_DIAG(5,6);
+
+  bool emit_diagnostic_valist (diagnostic_t, location_t, int, const char *,
+			       va_list *)
+    ATTRIBUTE_GCC_DIAG (5,0);
 
  private:
   bool m_emitted_header;
@@ -117,9 +147,6 @@ extern void inform_n (location_t, unsigned HOST_WIDE_INT, const char *,
 extern void verbatim (const char *, ...) ATTRIBUTE_GCC_DIAG(1,2);
 extern bool emit_diagnostic (diagnostic_t, location_t, int,
 			     const char *, ...) ATTRIBUTE_GCC_DIAG(4,5);
-extern bool emit_diagnostic_valist (diagnostic_t, location_t, int, const char *,
-				    va_list *, diagnostic_group *)
-  ATTRIBUTE_GCC_DIAG (4,0);
 extern bool seen_error (void);
 
 #ifdef BUFSIZ
diff --git a/gcc/diagnostic.c b/gcc/diagnostic.c
index 2d40845..425d3e6 100644
--- a/gcc/diagnostic.c
+++ b/gcc/diagnostic.c
@@ -49,12 +49,14 @@ along with GCC; see the file COPYING3.  If not see
 #define permissive_error_option(DC) ((DC)->opt_permissive)
 
 /* Prototypes.  */
-static bool diagnostic_impl (rich_location *, int, const char *,
-			     va_list *, diagnostic_t, diagnostic_group * = NULL)
-  ATTRIBUTE_GCC_DIAG(3,0);
-static bool diagnostic_n_impl (rich_location *, int, unsigned HOST_WIDE_INT,
+static bool diagnostic_impl (diagnostic_group *, rich_location *, int,
+			     const char *, va_list *, diagnostic_t)
+  ATTRIBUTE_GCC_DIAG(4,0);
+static bool diagnostic_n_impl (diagnostic_group *, rich_location *, int,
+			       unsigned HOST_WIDE_INT,
 			       const char *, const char *, va_list *,
-			       diagnostic_t) ATTRIBUTE_GCC_DIAG(5,0);
+			       diagnostic_t)
+  ATTRIBUTE_GCC_DIAG(6,0);
 
 static void error_recursion (diagnostic_context *) ATTRIBUTE_NORETURN;
 static void real_abort (void) ATTRIBUTE_NORETURN;
@@ -69,12 +71,16 @@ diagnostic_context *global_dc = &global_diagnostic_context;
 
 
 
+/* FIXME.  */
+
 diagnostic_group::~diagnostic_group ()
 {
   if (m_emitted_header)
     emit_footer ();
 }
 
+/* FIXME.  */
+
 void
 diagnostic_group::maybe_emit_header ()
 {
@@ -86,31 +92,24 @@ diagnostic_group::maybe_emit_header ()
   fprintf (stderr, "--------------------------------------------------------\n");
 }
 
+/* FIXME.  */
+
 void
 diagnostic_group::emit_footer ()
 {
   fprintf (stderr, "\n");
 }
 
-bool
-diagnostic_group::warning_at (location_t loc, int opt, const char *gmsgid, ...)
-{
-  va_list ap;
-  va_start (ap, gmsgid);
-  /* Pass in "this", so that we can group things.  */
-  bool ret = emit_diagnostic_valist (DK_WARNING, loc, opt, gmsgid, &ap, this);
-  va_end (ap);
-  return ret;
-}
+/* FIXME.  */
 
-void
-diagnostic_group::inform (location_t loc, const char *gmsgid, ...)
+bool
+diagnostic_group::emit_diagnostic_valist (diagnostic_t kind,
+					  location_t location, int opt,
+					  const char *gmsgid, va_list *ap)
 {
-  va_list ap;
-  va_start (ap, gmsgid);
+  rich_location richloc (line_table, location);
   /* Pass in "this", so that we can group things.  */
-  emit_diagnostic_valist (DK_NOTE, loc, -1, gmsgid, &ap, this);
-  va_end (ap);
+  return diagnostic_impl (this, &richloc, opt, gmsgid, ap, kind);
 }
 
 
@@ -1209,11 +1208,13 @@ diagnostic_append_note (diagnostic_context *context,
    permerror, error, error_at, error_at, sorry, fatal_error, internal_error,
    and internal_error_no_backtrace, as documented and defined below.  */
 static bool
-diagnostic_impl (rich_location *richloc, int opt,
+diagnostic_impl (diagnostic_group *group,
+		 rich_location *richloc, int opt,
 		 const char *gmsgid,
-		 va_list *ap, diagnostic_t kind,
-		 diagnostic_group *group)
+		 va_list *ap, diagnostic_t kind)
 {
+  gcc_assert (group);
+
   diagnostic_info diagnostic;
   if (kind == DK_PERMERROR)
     {
@@ -1234,11 +1235,14 @@ diagnostic_impl (rich_location *richloc, int opt,
 /* Implement inform_n, warning_n, and error_n, as documented and
    defined below.  */
 static bool
-diagnostic_n_impl (rich_location *richloc, int opt, unsigned HOST_WIDE_INT n,
+diagnostic_n_impl (diagnostic_group *group,rich_location *richloc, int opt,
+		   unsigned HOST_WIDE_INT n,
 		   const char *singular_gmsgid,
 		   const char *plural_gmsgid,
 		   va_list *ap, diagnostic_t kind)
 {
+  gcc_assert (group);
+
   diagnostic_info diagnostic;
   unsigned long gtn;
 
@@ -1254,6 +1258,7 @@ diagnostic_n_impl (rich_location *richloc, int opt, unsigned HOST_WIDE_INT n,
   diagnostic_set_info_translated (&diagnostic, text, ap, richloc, kind);
   if (kind == DK_WARNING)
     diagnostic.option_index = opt;
+  diagnostic.group = group;
   return diagnostic_report_diagnostic (global_dc, &diagnostic);
 }
 
@@ -1263,34 +1268,37 @@ bool
 emit_diagnostic (diagnostic_t kind, location_t location, int opt,
 		 const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, location);
-  bool ret = diagnostic_impl (&richloc, opt, gmsgid, &ap, kind);
+  bool ret = diagnostic_impl (&d, &richloc, opt, gmsgid, &ap, kind);
   va_end (ap);
   return ret;
 }
 
-/* Wrapper around diagnostic_impl taking a va_list parameter.  */
-
-bool
-emit_diagnostic_valist (diagnostic_t kind, location_t location, int opt,
-			const char *gmsgid, va_list *ap,
-			diagnostic_group *group)
+/* An informative note at LOCATION.  Use this for additional details on an error
+   message.  */
+void
+inform (location_t location, const char *gmsgid, ...)
 {
+  diagnostic_group d;
+  va_list ap;
+  va_start (ap, gmsgid);
   rich_location richloc (line_table, location);
-  return diagnostic_impl (&richloc, opt, gmsgid, ap, kind, group);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_NOTE);
+  va_end (ap);
 }
 
-/* An informative note at LOCATION.  Use this for additional details on an error
-   message.  */
+/* As above, but within a specific diagnostic_group.  */
+
 void
-inform (location_t location, const char *gmsgid, ...)
+diagnostic_group::inform (location_t location, const char *gmsgid, ...)
 {
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, location);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_NOTE);
+  diagnostic_impl (this, &richloc, -1, gmsgid, &ap, DK_NOTE);
   va_end (ap);
 }
 
@@ -1300,9 +1308,23 @@ inform (rich_location *richloc, const char *gmsgid, ...)
 {
   gcc_assert (richloc);
 
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
-  diagnostic_impl (richloc, -1, gmsgid, &ap, DK_NOTE);
+  diagnostic_impl (&d, richloc, -1, gmsgid, &ap, DK_NOTE);
+  va_end (ap);
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+void
+diagnostic_group::inform (rich_location *richloc, const char *gmsgid, ...)
+{
+  gcc_assert (richloc);
+
+  va_list ap;
+  va_start (ap, gmsgid);
+  diagnostic_impl (this, richloc, -1, gmsgid, &ap, DK_NOTE);
   va_end (ap);
 }
 
@@ -1314,8 +1336,23 @@ inform_n (location_t location, unsigned HOST_WIDE_INT n,
 {
   va_list ap;
   va_start (ap, plural_gmsgid);
+  diagnostic_group d;
   rich_location richloc (line_table, location);
-  diagnostic_n_impl (&richloc, -1, n, singular_gmsgid, plural_gmsgid,
+  diagnostic_n_impl (&d, &richloc, -1, n, singular_gmsgid, plural_gmsgid,
+		     &ap, DK_NOTE);
+  va_end (ap);
+}
+
+/* As above, but within a specific diagnostic_group.  */
+void
+diagnostic_group::inform_n (location_t location, unsigned HOST_WIDE_INT n,
+			    const char *singular_gmsgid,
+			    const char *plural_gmsgid, ...)
+{
+  va_list ap;
+  va_start (ap, plural_gmsgid);
+  rich_location richloc (line_table, location);
+  diagnostic_n_impl (this, &richloc, -1, n, singular_gmsgid, plural_gmsgid,
 		     &ap, DK_NOTE);
   va_end (ap);
 }
@@ -1323,74 +1360,124 @@ inform_n (location_t location, unsigned HOST_WIDE_INT n,
 /* A warning at INPUT_LOCATION.  Use this for code which is correct according
    to the relevant language specification but is likely to be buggy anyway.
    Returns true if the warning was printed, false if it was inhibited.  */
-void
+bool
 warning (int opt, const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, input_location);
-  diagnostic_impl (&richloc, opt, gmsgid, &ap, DK_WARNING);
+  bool ret = diagnostic_impl (&d, &richloc, opt, gmsgid, &ap, DK_WARNING);
+  va_end (ap);
+  return ret;
+}
+
+/* As above, but within a specific diagnostic_group.  */
+bool
+diagnostic_group::warning (int opt, const char *gmsgid, ...)
+{
+  rich_location richloc (line_table, input_location);
+  va_list ap;
+  va_start (ap, gmsgid);
+  bool ret = diagnostic_impl (this, &richloc, opt, gmsgid, &ap, DK_WARNING);
   va_end (ap);
+  return ret;
 }
 
 /* A warning at LOCATION.  Use this for code which is correct according to the
    relevant language specification but is likely to be buggy anyway.
    Returns true if the warning was printed, false if it was inhibited.  */
 
-void
+bool
 warning_at (location_t location, int opt, const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, location);
-  diagnostic_impl (&richloc, opt, gmsgid, &ap, DK_WARNING);
+  bool ret = diagnostic_impl (&d, &richloc, opt, gmsgid, &ap, DK_WARNING);
   va_end (ap);
+  return ret;
 }
 
 /* Same as "warning at" above, but using RICHLOC.  */
 
-void
+bool
 warning_at (rich_location *richloc, int opt, const char *gmsgid, ...)
 {
   gcc_assert (richloc);
 
+  diagnostic_group d;
+  va_list ap;
+  va_start (ap, gmsgid);
+  bool ret = diagnostic_impl (&d, richloc, opt, gmsgid, &ap, DK_WARNING);
+  va_end (ap);
+  return ret;
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+bool
+diagnostic_group::warning_at (location_t loc, int opt, const char *gmsgid, ...)
+{
+  rich_location richloc (line_table, loc);
+  va_list ap;
+  va_start (ap, gmsgid);
+  bool ret = diagnostic_impl (this, &richloc, opt, gmsgid, &ap, DK_WARNING);
+  va_end (ap);
+  return ret;
+}
+
+/* Same as "warning at" above, but using RICHLOC.  */
+
+bool
+diagnostic_group::warning_at (rich_location *richloc, int opt,
+			      const char *gmsgid, ...)
+{
+  gcc_assert (richloc);
+
   va_list ap;
   va_start (ap, gmsgid);
-  diagnostic_impl (richloc, opt, gmsgid, &ap, DK_WARNING);
+  bool ret = diagnostic_impl (this, richloc, opt, gmsgid, &ap, DK_WARNING);
   va_end (ap);
+  return ret;
 }
 
 /* Same as warning_n plural variant below, but using RICHLOC.  */
 
-void
+bool
 warning_n (rich_location *richloc, int opt, unsigned HOST_WIDE_INT n,
 	   const char *singular_gmsgid, const char *plural_gmsgid, ...)
 {
   gcc_assert (richloc);
 
+  diagnostic_group d;
   va_list ap;
   va_start (ap, plural_gmsgid);
-  diagnostic_n_impl (richloc, opt, n,
-		     singular_gmsgid, plural_gmsgid,
-		     &ap, DK_WARNING);
+  bool ret = diagnostic_n_impl (&d, richloc, opt, n,
+				singular_gmsgid, plural_gmsgid,
+				&ap, DK_WARNING);
   va_end (ap);
+  return ret;
 }
 
 /* A warning at LOCATION.  Use this for code which is correct according to the
    relevant language specification but is likely to be buggy anyway.
    Returns true if the warning was printed, false if it was inhibited.  */
 
-void
+bool
 warning_n (location_t location, int opt, unsigned HOST_WIDE_INT n,
 	   const char *singular_gmsgid, const char *plural_gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, plural_gmsgid);
   rich_location richloc (line_table, location);
-  diagnostic_n_impl (&richloc, opt, n,
-		     singular_gmsgid, plural_gmsgid,
-		     &ap, DK_WARNING);
+  bool ret = diagnostic_n_impl (&d, &richloc, opt, n,
+				singular_gmsgid, plural_gmsgid,
+				&ap, DK_WARNING);
   va_end (ap);
+  return ret;
 }
 
 /* A "pedantic" warning at LOCATION: issues a warning unless
@@ -1406,27 +1493,60 @@ warning_n (location_t location, int opt, unsigned HOST_WIDE_INT n,
 
    Returns true if the warning was printed, false if it was inhibited.  */
 
-void
+bool
 pedwarn (location_t location, int opt, const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, location);
-  diagnostic_impl (&richloc, opt, gmsgid, &ap, DK_PEDWARN);
+  bool ret = diagnostic_impl (&d, &richloc, opt, gmsgid, &ap, DK_PEDWARN);
   va_end (ap);
+  return ret;
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+bool
+diagnostic_group::pedwarn (location_t location, int opt, const char *gmsgid,
+			   ...)
+{
+  va_list ap;
+  va_start (ap, gmsgid);
+  rich_location richloc (line_table, location);
+  bool ret = diagnostic_impl (this, &richloc, opt, gmsgid, &ap, DK_PEDWARN);
+  va_end (ap);
+  return ret;
 }
 
 /* Same as pedwarn above, but using RICHLOC.  */
 
-void
+bool
 pedwarn (rich_location *richloc, int opt, const char *gmsgid, ...)
 {
   gcc_assert (richloc);
 
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
-  diagnostic_impl (richloc, opt, gmsgid, &ap, DK_PEDWARN);
+  bool ret = diagnostic_impl (&d, richloc, opt, gmsgid, &ap, DK_PEDWARN);
   va_end (ap);
+  return ret;
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+bool
+diagnostic_group::pedwarn (rich_location *richloc, int opt, const char *gmsgid,
+			   ...)
+{
+  gcc_assert (richloc);
+
+  va_list ap;
+  va_start (ap, gmsgid);
+  bool ret = diagnostic_impl (this, richloc, opt, gmsgid, &ap, DK_PEDWARN);
+  va_end (ap);
+  return ret;
 }
 
 /* A "permissive" error at LOCATION: issues an error unless
@@ -1436,27 +1556,44 @@ pedwarn (rich_location *richloc, int opt, const char *gmsgid, ...)
 
    Returns true if the warning was printed, false if it was inhibited.  */
 
-void
+bool
 permerror (location_t location, const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, location);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_PERMERROR);
+  bool ret = diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_PERMERROR);
   va_end (ap);
+  return ret;
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+bool
+diagnostic_group::permerror (location_t location, const char *gmsgid, ...)
+{
+  va_list ap;
+  va_start (ap, gmsgid);
+  rich_location richloc (line_table, location);
+  bool ret = diagnostic_impl (this, &richloc, -1, gmsgid, &ap, DK_PERMERROR);
+  va_end (ap);
+  return ret;
 }
 
 /* Same as "permerror" above, but at RICHLOC.  */
 
-void
+bool
 permerror (rich_location *richloc, const char *gmsgid, ...)
 {
   gcc_assert (richloc);
 
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
-  diagnostic_impl (richloc, -1, gmsgid, &ap, DK_PERMERROR);
+  bool ret = diagnostic_impl (&d, richloc, -1, gmsgid, &ap, DK_PERMERROR);
   va_end (ap);
+  return ret;
 }
 
 /* A hard error: the code is definitely ill-formed, and an object file
@@ -1464,10 +1601,22 @@ permerror (rich_location *richloc, const char *gmsgid, ...)
 void
 error (const char *gmsgid, ...)
 {
+  diagnostic_group d;
+  va_list ap;
+  va_start (ap, gmsgid);
+  rich_location richloc (line_table, input_location);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_ERROR);
+  va_end (ap);
+}
+
+/* As above, but within a specific diagnostic_group.  */
+void
+diagnostic_group::error (const char *gmsgid, ...)
+{
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, input_location);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_ERROR);
+  diagnostic_impl (this, &richloc, -1, gmsgid, &ap, DK_ERROR);
   va_end (ap);
 }
 
@@ -1477,10 +1626,11 @@ void
 error_n (location_t location, unsigned HOST_WIDE_INT n,
 	 const char *singular_gmsgid, const char *plural_gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, plural_gmsgid);
   rich_location richloc (line_table, location);
-  diagnostic_n_impl (&richloc, -1, n, singular_gmsgid, plural_gmsgid,
+  diagnostic_n_impl (&d, &richloc, -1, n, singular_gmsgid, plural_gmsgid,
 		     &ap, DK_ERROR);
   va_end (ap);
 }
@@ -1489,10 +1639,23 @@ error_n (location_t location, unsigned HOST_WIDE_INT n,
 void
 error_at (location_t loc, const char *gmsgid, ...)
 {
+  diagnostic_group d;
+  va_list ap;
+  va_start (ap, gmsgid);
+  rich_location richloc (line_table, loc);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_ERROR);
+  va_end (ap);
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+void
+diagnostic_group::error_at (location_t loc, const char *gmsgid, ...)
+{
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, loc);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_ERROR);
+  diagnostic_impl (this, &richloc, -1, gmsgid, &ap, DK_ERROR);
   va_end (ap);
 }
 
@@ -1503,9 +1666,23 @@ error_at (rich_location *richloc, const char *gmsgid, ...)
 {
   gcc_assert (richloc);
 
+  diagnostic_group d;
+  va_list ap;
+  va_start (ap, gmsgid);
+  diagnostic_impl (&d, richloc, -1, gmsgid, &ap, DK_ERROR);
+  va_end (ap);
+}
+
+/* As above, but within a specific diagnostic_group.  */
+
+void
+diagnostic_group::error_at (rich_location *richloc, const char *gmsgid, ...)
+{
+  gcc_assert (richloc);
+
   va_list ap;
   va_start (ap, gmsgid);
-  diagnostic_impl (richloc, -1, gmsgid, &ap, DK_ERROR);
+  diagnostic_impl (this, richloc, -1, gmsgid, &ap, DK_ERROR);
   va_end (ap);
 }
 
@@ -1515,10 +1692,11 @@ error_at (rich_location *richloc, const char *gmsgid, ...)
 void
 sorry (const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, input_location);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_SORRY);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_SORRY);
   va_end (ap);
 }
 
@@ -1536,10 +1714,11 @@ seen_error (void)
 void
 fatal_error (location_t loc, const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, loc);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_FATAL);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_FATAL);
   va_end (ap);
 
   gcc_unreachable ();
@@ -1552,10 +1731,11 @@ fatal_error (location_t loc, const char *gmsgid, ...)
 void
 internal_error (const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, input_location);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_ICE);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_ICE);
   va_end (ap);
 
   gcc_unreachable ();
@@ -1567,10 +1747,11 @@ internal_error (const char *gmsgid, ...)
 void
 internal_error_no_backtrace (const char *gmsgid, ...)
 {
+  diagnostic_group d;
   va_list ap;
   va_start (ap, gmsgid);
   rich_location richloc (line_table, input_location);
-  diagnostic_impl (&richloc, -1, gmsgid, &ap, DK_ICE_NOBT);
+  diagnostic_impl (&d, &richloc, -1, gmsgid, &ap, DK_ICE_NOBT);
   va_end (ap);
 
   gcc_unreachable ();
diff --git a/gcc/gimple-ssa-isolate-paths.c b/gcc/gimple-ssa-isolate-paths.c
index 131705d..0557aff 100644
--- a/gcc/gimple-ssa-isolate-paths.c
+++ b/gcc/gimple-ssa-isolate-paths.c
@@ -421,12 +421,15 @@ find_implicit_erroneous_behavior (void)
 			  if (gimple_return_retval (return_stmt) != lhs)
 			    continue;
 
-			  if (warning_at (gimple_location (use_stmt),
-					  OPT_Wreturn_local_addr,
-					  "function may return address "
-					  "of local variable"))
-			    inform (DECL_SOURCE_LOCATION(valbase),
-				    "declared here");
+			  {
+			    diagnostic_group d;
+			    if (d.warning_at (gimple_location (use_stmt),
+					      OPT_Wreturn_local_addr,
+					      "function may return address "
+					      "of local variable"))
+			      d.inform (DECL_SOURCE_LOCATION(valbase),
+					"declared here");
+			  }
 
 			  if (gimple_bb (use_stmt) == bb)
 			    {
@@ -534,19 +537,23 @@ find_explicit_erroneous_behavior (void)
 		    {
 		      /* We only need it for this particular case.  */
 		      calculate_dominance_info (CDI_POST_DOMINATORS);
-		      const char* msg;
-		      bool always_executed = dominated_by_p
-			(CDI_POST_DOMINATORS,
-			 single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)), bb);
-		      if (always_executed)
-			msg = N_("function returns address of local variable");
-		      else
-			msg = N_("function may return address of "
-				 "local variable");
-
-		      if (warning_at (gimple_location (stmt),
-				      OPT_Wreturn_local_addr, msg))
-			inform (DECL_SOURCE_LOCATION(valbase), "declared here");
+		      {
+			diagnostic_group d;
+			const char* msg;
+			bool always_executed = dominated_by_p
+			  (CDI_POST_DOMINATORS,
+			   single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)), bb);
+			if (always_executed)
+			  msg = N_("function returns address of "
+				   "local variable");
+			else
+			  msg = N_("function may return address of "
+				   "local variable");
+			if (d.warning_at (gimple_location (stmt),
+					  OPT_Wreturn_local_addr, msg))
+			  d.inform (DECL_SOURCE_LOCATION(valbase),
+				    "declared here");
+		      }
 		      tree zero = build_zero_cst (TREE_TYPE (val));
 		      gimple_return_set_retval (return_stmt, zero);
 		      update_stmt (stmt);
diff --git a/gcc/gimple-ssa-warn-alloca.c b/gcc/gimple-ssa-warn-alloca.c
index 0331f66..5e3b6bf 100644
--- a/gcc/gimple-ssa-warn-alloca.c
+++ b/gcc/gimple-ssa-warn-alloca.c
@@ -532,29 +532,37 @@ pass_walloca::execute (function *fun)
 	    case ALLOCA_OK:
 	      break;
 	    case ALLOCA_BOUND_MAYBE_LARGE:
-	      if (warning_at (loc, wcode,
-			      is_vla ? G_("argument to variable-length array "
-					  "may be too large")
-			      : G_("argument to %<alloca%> may be too large"))
-		  && t.limit != 0)
-		{
-		  print_decu (t.limit, buff);
-		  inform (loc, G_("limit is %wu bytes, but argument "
-				  "may be as large as %s"),
-			  is_vla ? warn_vla_limit : warn_alloca_limit, buff);
-		}
+	      {
+		diagnostic_group d;
+		if (d.warning_at (loc, wcode,
+				  is_vla ? G_("argument to variable-length "
+					      "array may be too large")
+				  : G_("argument to %<alloca%> may be too "
+				       "large"))
+		    && t.limit != 0)
+		  {
+		    print_decu (t.limit, buff);
+		    d.inform (loc, G_("limit is %wu bytes, but argument "
+				    "may be as large as %s"),
+			    is_vla ? warn_vla_limit : warn_alloca_limit, buff);
+		  }
+	      }
 	      break;
 	    case ALLOCA_BOUND_DEFINITELY_LARGE:
-	      if (warning_at (loc, wcode,
-			      is_vla ? G_("argument to variable-length array "
-					  "is too large")
-			      : G_("argument to %<alloca%> is too large"))
-		  && t.limit != 0)
-		{
-		  print_decu (t.limit, buff);
-		  inform (loc, G_("limit is %wu bytes, but argument is %s"),
-			  is_vla ? warn_vla_limit : warn_alloca_limit, buff);
-		}
+	      {
+		diagnostic_group d;
+		if (d.warning_at (loc, wcode,
+				  is_vla ? G_("argument to variable-length"
+					      " array is too large")
+				  : G_("argument to %<alloca%> is too large"))
+		    && t.limit != 0)
+		  {
+		    print_decu (t.limit, buff);
+		    d.inform (loc, G_("limit is %wu bytes, but argument is %s"),
+			      is_vla ? warn_vla_limit : warn_alloca_limit,
+			      buff);
+		  }
+	      }
 	      break;
 	    case ALLOCA_BOUND_UNKNOWN:
 	      warning_at (loc, wcode,
